<template>
  <div class="pagination">
    <a v-if="currentPage != 1" @click.prevent="goToPage(1)"><<</a>
    <a v-if="currentPage != 1" @click.prevent="goToPrev"><</a>
    <span v-if="firstDisplayedPage != 1">...</span>

    <template v-for="page in pagesToDisplay">
      <a v-if="currentPage != page" class="page-link" @click.prevent="goToPage(page)" :key="page"> {{ page }} </a>
      <span v-else :key="page" class="active">{{ page }}</span>
    </template>

    <span v-if="lastDisplayedPage != totalPages">...</span>
    <a v-if="currentPage != totalPages" @click.prevent="goToNext">></a>
    <a v-if="currentPage != totalPages" @click.prevent="goToPage(totalPages)">>></a>
  </div>
</template>

<script>
import { range } from 'lodash'

export default {
  props: {
    currentPage: {
      type: Number,
      default: 1,
    },
    totalPages: {
      type: Number,
      default: 5,
    },
    displayedPagesCount: {
      type: Number,
      default: 5,
    },
  },
  computed: {
    firstDisplayedPage() {
      if (this.currentPage - this.displayedPagesCount < 1) {
        return 1
      } else {
        return this.currentPage - this.displayedPagesCount
      }
    },
    lastDisplayedPage() {
      if (this.currentPage + this.displayedPagesCount > this.totalPages) {
        return this.totalPages
      } else {
        return this.currentPage + this.displayedPagesCount
      }
    },
    pagesToDisplay() {
      return range(this.firstDisplayedPage, this.lastDisplayedPage + 1)
    },
  },
  methods: {
    goToPrev() {
      this.$emit('goToPage', this.currentPage - 1)
    },
    goToNext() {
      this.$emit('goToPage', this.currentPage + 1)
    },
    goToPage(page) {
      this.$emit('goToPage', page)
    },
  },
}
</script>

<style lang="sass" scoped>
.pagination
  display: inline-block
  a,span
    color: black;
    float: left;
    padding: 8px 16px;
    text-decoration: none;
    border: 1px solid #ddd;
    cursor: pointer
    &.active
      color: white
      background-color: #3cabe2
      border: 1px solid #3cabe2
    &:hover:not(.active)
      background-color: #ddd
    &:first-child
      border-top-left-radius: 5px
      border-bottom-left-radius: 5px
    &:last-child
      border-top-right-radius: 5px
      border-bottom-right-radius: 5px
</style>
